<?php
require_once('clients/base/api/CurrentUserApi.php');
require_once('modules/Iframeapp/Iframeapp.php');

class Inbox25UserApi extends CurrentUserApi {

  /**
   * Override the core api with our own version of retrieveCurrentUser that will
   * include the INBOX25 URL and encrypted timestamp
   */
  public function registerApiRest() {
    return array(
      'retrieve' => array(
      'reqType' => 'GET',
      'path' => array('me',),
      'pathVars' => array('module', 'record'),
      'method' => 'retrieveCurrentUser',
      'shortHelp' => 'Returns current user',
      'longHelp' => 'include/api/help/me_get_help.html',
      'ignoreMetaHash' => true,
      'ignoreSystemStatusError' => true,
      )
    );
  }

  public function retrieveCurrentUser($api, $args) {

    // load current values or defaults for the INBOX25 URL
    global $sugar_config;
    $url = !empty($sugar_config['inbox25']['url']) ? $sugar_config['inbox25']['url'] : 'https://www.inbox25.com/timelinefail.php';

    // get the current user data array and append our INBOX25 URL and timestamp
    $user_data_array = parent::retrieveCurrentUser($api, $args);
    $user_data_array['current_user']['inbox25_url'] = $url;
    $user_data_array['current_user']['inbox25_url_ts'] = Iframeapp::get_url_ts();
    list($apiURL, $apiQueryString) = Iframeapp::getListenerURL();
    $user_data_array['current_user']['inbox25_api_url'] = $apiURL;
    $user_data_array['current_user']['inbox25_api_params'] = $apiQueryString;
    $user_data_array['current_user']['inbox25_mv'] = Iframeapp::get_module_version();
    $user_data_array['current_user']['inbox25_system'] = Iframeapp::get_system_version();
    $user_data_array['current_user']['inbox25_suid'] = '&suid='.(isset($GLOBALS['current_user']->id) ? $GLOBALS['current_user']->id : NULL);

    return $user_data_array;
  }
}
