<?php
require_once('modules/Iframeapp/Iframeapp.php');
class DispatchData {
  public $url;

  private function get_email_address_info($bean) {
    $sugar_email = '';
    $invalid_email = 0;
    $opt_out = 0;
    if (isset($bean->emailAddress->addresses)) {
      foreach( $bean->emailAddress->addresses as $item ) {
        if( $item['primary_address'] == 1 ) {
          $sugar_email = $item['email_address'];
          $invalid_email = $item['invalid_email'];
          $opt_out = $item['opt_out'];
          break;
        }
      }
    }
    return array($sugar_email, $invalid_email, $opt_out);
  }

  public function ProcessMod($bean, $event, $arguments) {

    static $called_inbox25 = 0;
    $timestamp1 = strtotime('now') + date('Z');
    $action_type = 'Import';
    $mass_called = 0;

    // if we've already fired, exit now
    if($called_inbox25 == 1) {
      return TRUE;
    }

    if(isset($_REQUEST['__sugar_url']) && strpos($_REQUEST['__sugar_url'],'/MassUpdate')){
      $action_type = 'mass_update';
      $mass_called = 1;
    }

    if(
      (isset($_REQUEST['action']) && $_REQUEST['action'] == 'Step4' || $mass_called)
      && !$called_inbox25
    ) {
      $_SESSION['import_id'] = uniqid();
      $_SESSION['timestamp_inbox'] = $timestamp1;
      $called_inbox25 = 1;
      $GLOBALS['log']->debug($action_type . " Called by LeadFWD:session_timestamp: " . $_SESSION['timestamp_inbox']);
      $postdata = array(
        'sugar_module' => $bean->module_dir,
        'sugar_id' => $bean->id,
        'action_type' => $action_type,
        'action_time' => $timestamp1,
        'import_id' =>$_SESSION['import_id'],
      );
      $ret = $this->sendData($postdata);
    }
    elseif($event == 'after_relationship_add' || $event == 'after_relationship_delete') {
      $called_inbox25 = 1;
      $postdata = array(
        'sugar_module' => $bean->module_dir,
        'sugar_id' => $bean->id,
        'action_type' => $event,
        'action_time' => $timestamp1,
      );
      $ret = $this->sendData($postdata);
    }
    elseif(isset($_REQUEST['action']) && $_REQUEST['action']=='Undo') {
      $postdata = array(
        'sugar_module' => $bean->module_dir,
        'sugar_id' => $bean->id,
        'action_type' => 'Undo_Import',
        'action_time' => $_SESSION['timestamp_inbox'],
        'import_id' => $_SESSION['import_id'],
      );
      $ret = $this->sendData($postdata);
    }
    else {
      if(Iframeapp::get_config_url() && Iframeapp::enableLogicHooks()) {

        list($sugar_email, $invalid_email, $opt_out) = $this->get_email_address_info($bean);

        if($bean->deleted == 1) {
          $action_type = 'delete';
        }
        elseif(empty($bean->fetched_row)) {
          $action_type = 'add';
        }
        else {
          $action_type = 'edit';
        }

        $postdata = array(
          'sugar_module' => $bean->module_dir,
          'sugar_id' => $bean->id,
          'sugar_email' => $sugar_email,
          'invalid_email' => $invalid_email,
          'opt_out' => $opt_out,
          'action_type' => $action_type
        );

        $ret = $this->sendData($postdata);
      }
    }
  }

  /**
   * called from the custom ImportController kept in custom/modules/Import/controller.php
   */
  public function set_undo($mod){
    $postdata = array(
      'sugar_module' => $mod,
      'sugar_id' => '',
      'action_type' => 'Undo_Import',
      'action_time' => $_SESSION['timestamp_inbox'],
      'import_id' => $_SESSION['import_id'],
    );
    $GLOBALS['log']->debug("Undo Called For INBOX25:session_timestamp: " . $_SESSION['timestamp_inbox']);
    $ret = $this->sendData($postdata);
  }

  public function ProcessRel($bean, $event, $arguments) {
    if(Iframeapp::get_config_url() && Iframeapp::enableLogicHooks()) {
      list($sugar_email, $invalid_email, $opt_out) = $this->get_email_address_info($bean);
      $postdata = array(
        'sugar_module' => $arguments['module'],
        'sugar_id' => $arguments['id'],
        'sugar_email' => $sugar_email,
        'invalid_email' => $invalid_email,
        'opt_out' => $opt_out,
        'action_type' => 'rel',
      );
      $ret = $this->sendData($postdata);
    }
  }

  public function ProcessDelRel($bean, $event, $arguments) {
    $iframe_src = Iframeapp::get_config_url();
    if($iframe_src) {
      $postdata = array(
        'sugar_module' => $arguments['module'],
        'sugar_id' => $arguments['id'],
        'action_type' => 'rel'
      );
      $ret = $this->sendData($postdata);
    }
  }

  private function sendData($postdata) {

    $queryString = '';

    $iframe_src = Iframeapp::get_config_url();
    if($iframe_src && Iframeapp::enableLogicHooks()) {
      list($url, $queryString) = Iframeapp::getListenerURL();
    } else {
      return FALSE;
    }

    foreach( $postdata as $fieldName => $fieldValue ) {
      $queryString .= '&' . $fieldName . '=' . $fieldValue;
    }
    $queryString .= Iframeapp::get_url_ts();

    $ch = curl_init($url);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $queryString);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 10);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    $return_data = curl_exec($ch);
    curl_close($ch);
    return $return_data;
  }
}
