{literal}

<style type='text/css'>
  /* div#main should ensure this only applies to Sugar CE Classic UI */
  div#main .nav.nav-tabs.clickMenu li.active a {
    color: white;
    border-color: #4e8ccf;
    background-color: #4e8ccf;
  }
  /* bootstrap-container ref ensures this will only present on the SuiteCRM UI,
     and these will un-do some of the funny positioning that the clickMenu class
     adds */
  div#bootstrap-container .nav.nav-tabs.clickMenu {
    display: block;
  }
  div#bootstrap-container .nav.nav-tabs.clickMenu > li {
    padding: 0;
  }
</style>

<div class='content' style='padding:0'>
  <ul class='nav nav-tabs clickMenu'>
    <li class='hidden-xs'><a href='javascript:' id='inbx25_btn_timeline' onclick='inbox25_toggle_button(this.id);'>Timeline</a></li>
    <li class='hidden-xs'><a href='javascript:' id='inbx25_btn_vision' onclick='inbox25_toggle_button(this.id);'>Vision</a></li>
    <li class='hidden-xs'><a href='javascript:' id='inbx25_btn_toggle_hide' onclick='inbox25_toggle_button(this.id);'>Hide LeadFWD</a></li>
  </ul>
  <iframe class='tab-content' style='border-width:0' id='inbox25_url' width='100%' height='500px' src=''></iframe>
</div>

<script type='text/javascript'>
  function inbox25_toggle_button(id, check_cookie_first) {

    // handle check-cookie var and checking
    if(typeof(check_cookie_first) == 'undefined') {
      var check_cookie_first = false;
    }

    if(check_cookie_first) {
      var INBOX25_last_button = INBOX25_cookie();
      if(typeof(INBOX25_last_button) != 'undefined') {
        inbox25_toggle_button(INBOX25_last_button);
        return;
      }
    }

    // exit if no change is necessary
    var current_class = $('#' + id).parent().attr('class');
    if(current_class == 'active') {
      return;
    }

    // set inactive and active classes
    $('#' + id).parent().parent().children().attr('class','hidden-xs');
    $('#' + id).parent().attr('class','active');

    // set user preference for the panel with a cookie
    INBOX25_cookie(id);

    // When we click "Hide LeadFWD" and the iframe is visible, hide it
    if(id == 'inbx25_btn_toggle_hide') {
      if($('#inbox25_url').css('height') != '1px') {
        $('#inbox25_url').css('height', '1px');
        return;
      }
    }
    // if Timeline or Vision are clicked, make sure we're showing the iframe
    else {
      $('#inbox25_url').css('height', '');
    }

    // load/reload the iframe. this is similar to iframe buildup in
    // custom/clients/base/views/inbox25/inbox25.js
    // but adjusted to be pure JS/AJAX and retrieve URL and iframe height config
    // options from entryPoint
    $.ajax({
      iFrameType: id,
      sugar_record: $('#formDetailView input[name=record]').val(),
      sugar_module: $('#formDetailView input[name=module]').val(),
      inbox_25_url: '',
      url: "index.php?entryPoint=inbox25_url&fullurlandheight=true",
      success: function(result) {
        result = JSON.parse(result);

        // reset the height of the iframe element to match config
        $('#inbox25_url').attr('height', result.iframe_height);

        // build the iframe URL with configured INBOX25 URL, info. on this
        // particular record, and timestamp
        this.inbox_25_url = result.config_url;
        if(result.config_url != 'https://www.inbox25.com/timelinefail.php') {
          if(this.iFrameType == 'inbx25_btn_vision') {
            this.inbox_25_url += '&sugar_id_vision=';
          }
          else {
            this.inbox_25_url += (this.sugar_module == 'Opportunities') ? '&sugar_id_opp=' : '&sugar_id=';
          }
          this.inbox_25_url += this.sugar_record;
          this.inbox_25_url += '&sugar_module=';
          this.inbox_25_url += this.sugar_module;
          this.inbox_25_url += result.ts;
          this.inbox_25_url += result.suid;
          this.inbox_25_url += result.system;
        }
        $('#inbox25_url').attr('src', this.inbox_25_url);
      },
      error: function(result) {
        alert('Unable to load LeadFWD Frame');
      }
    });
  }

  // set the last-clicked-button cookie, or read it if no value is given
  // yeah, we could use $.cookie for most of SuiteCRM, but SugarCRM CE 6.5
  // didn't include it.
  function INBOX25_cookie(value) {
    var cookie_name = 'INBOX25_last_button';
    if(typeof(value) == 'undefined') {
      // https://stackoverflow.com/a/25490531
      var b = document.cookie.match('(^|;)\\s*' + cookie_name + '\\s*=\\s*([^;]+)');
      return b ? b.pop() : '';
    }
    else {
      // will expire in 30 days
      var d = new Date();
      d.setTime(d.getTime() + (30*24*60*60*1000));
      document.cookie = cookie_name + '=' + value + ';expires=' + d.toUTCString();
    }
  }

  // original invocation
  inbox25_toggle_button('inbx25_btn_timeline', true);
</script>
{/literal}
