<?php
if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$module = $_REQUEST['module'];
$recordIdList = $_REQUEST['recordIdList'];
$recordList = array();

if(in_array($module, array('Accounts', 'Opportunities'))) {
  $module = 'Contacts';
}

if($module == 'ProspectLists') {
  foreach($recordIdList as $recordId) {
    $focus = BeanFactory::getBean($module, $recordId);
    $count = $focus->get_entry_count();
    if(empty($count)) {
      $recordList[] = array(
        'id' => $focus->id,
        'name' => $focus->name,
        'email' => '',
        'status' => 'Empty',
        'status_color' => 'red',
      );
    } else {
      $recordList[] = array(
        'id' => $focus->id,
        'name' => $focus->name,
        'email' => '',
        'status' => 'Valid, ' . $count . ' entries',
        'status_color' => 'green',
      );
    }
  }
} else {
  $sugarEmailAddress = new SugarEmailAddress();
  foreach($recordIdList as $recordId) {

    $focus = BeanFactory::getBean($module, $recordId);

    $status = 'Missing Email Address';
    $status_color = 'red';
    $primary_email_address = '';

    $emailAddressList = $sugarEmailAddress->getAddressesByGUID($focus->id, $module);
    foreach($emailAddressList as $emailAddress) {
      if(!empty($emailAddress['primary_address'])) {
        $primary_email_address = $emailAddress['email_address'];
        if($emailAddress['invalid_email'] && $emailAddress['opt_out']) {
          $status = 'Invalid Email Address and Opted-out';
        } else if($emailAddress['invalid_email']) {
          $status = 'Invalid Email Address';
        } else if($emailAddress['opt_out']) {
          $status = 'Opted-out';
        } else {
          $status = 'Valid';
          $status_color = 'green';
        }
      }
    }

    $recordName = $focus->name;
    if(isset($focus->title) && !empty($focus->title)) $recordName .= " ({$focus->title})";

    $recordList[] = array(
      'id' => $focus->id,
      'name' => $recordName,
      'email' => $primary_email_address,
      'status' => $status,
      'status_color' => $status_color,
    );

  }
}

require_once('modules/Iframeapp/Iframeapp.php');
$url = Iframeapp::get_config_url() . '&eq=1&suid=' . $GLOBALS['current_user']->id . Iframeapp::get_url_ts() . Iframeapp::get_system_version();

$ch = curl_init($url);
curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_URL, $url);
$curlResponse = curl_exec($ch);
$curlError = curl_error($ch);
$curlResponseCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
curl_close($ch);

$message = null;
$salesSequenceList = json_decode($curlResponse);

if($curlResponseCode != 200) {
  $message = 'Unsuccessful response code. Expected 200 but got ' . $curlResponseCode . PHP_EOL;
  if(!empty($curlResponse)) $message .= $curlResponse . PHP_EOL;
  if(!empty($curlError)) $message .= $curlError . PHP_EOL;
  $message = trim($message);
} elseif(empty($curlResponse)) {
  $message = 'Sales Sequence list appears to be empty';
} elseif(empty($salesSequenceList)) {
  $message = 'exception around Sales Sequence list formatting' . PHP_EOL . $curlResponse;
}
if(!empty($message)) {
  echo json_encode(array(
    'message' => $message,
    'success' => false,
  ));
  die();
}

// is there at least one valid record?
$success = false;
$message = 'there are no valid records';
foreach($recordList as $record) {
  if($record['status_color'] == 'green') {
    $success = true;
    $message = '';
    continue;
  }
}

echo json_encode(array(
  'message' => $message,
  'module' => $module,
  'recordIdList' => $recordIdList,
  'recordList' => $recordList,
  'salesSequenceList' => $salesSequenceList,
  'success' => $success,
));
