
///////////////////////////////////////////////////////////////////////////
// Much of this was derived or copied from send_mass_update
// jssource/src_files/include/javascript/sugar_3.js
///////////////////////////////////////////////////////////////////////////
function openSalesSequenceModalFromListView(el) {

    /////////////////////////////////////////////////////////////////////////
    // Gathers the IDs of the selected records (array recordIdList)
    /////////////////////////////////////////////////////////////////////////

    var formValid = check_form('MassUpdate');
    if (!formValid) {
        alert("encountered an error in the form");
        return;
    }

    // @TODO
    // DO A BETTER JOB OF DETECTING WHEN THE ENTIRE LIST IS UNDER 20 RECORDS
    if (document.MassUpdate.select_entire_list && document.MassUpdate.select_entire_list.value == 1) {
        alert("Sales Sequence cannot accommodate the entire record list");
        return;
    }

    var module = '';
    var recordIdList = new Array();
    for (var wp = 0; wp < document.MassUpdate.elements.length; wp++) {
        var reg_for_existing_uid = new RegExp('^' + RegExp.escape(document.MassUpdate.elements[wp].value) + '[\s]*,|,[\s]*' + RegExp.escape(document.MassUpdate.elements[wp].value) + '[\s]*,|,[\s]*' + RegExp.escape(document.MassUpdate.elements[wp].value) + '$|^' + RegExp.escape(document.MassUpdate.elements[wp].value) + '$');
        //when the uid is already in document.MassUpdate.uid.value, we should not add it to ar.
        if (typeof document.MassUpdate.elements[wp].name != 'undefined'
        && document.MassUpdate.elements[wp].name == 'mass[]'
        && document.MassUpdate.elements[wp].checked
        && !reg_for_existing_uid.test(document.MassUpdate.uid.value)) {
            recordIdList.push(document.MassUpdate.elements[wp].value);
        } else if (typeof document.MassUpdate.elements[wp].name != 'undefined'
        && document.MassUpdate.elements[wp].name == 'module') {
            module = document.MassUpdate.elements[wp].value;
        }
    }

    if (recordIdList.length < 1) {
        alert("no records were selected");
        return;
    }

    openSalesSequenceDialog(module, recordIdList);
}

///////////////////////////////////////////////////////////////////////////
// Opens the modal, builds record list, retrieves records' details from
// the helper API
///////////////////////////////////////////////////////////////////////////
function openSalesSequenceModalFromRecordView(el) {

    var module = $('#formDetailView input[name=module]').val();
    var recordID = $('#formDetailView input[name=record]').val();

    $.ajax({
        method: "GET",
        url: "index.php?entryPoint=leadfwd_salessequence_from_recordview_helper&module="+module+"&id="+recordID,
        success: function(result) {
            result = JSON.parse(result);
            if(!result.success && result.message) {
                alert(result.message);
                return;
            }
            if (result.recordIdList.length < 1) {
                alert("no records were selected");
                return;
            }
            openSalesSequenceDialog(module, result.recordIdList);
        },
        error: function(result) {
            alert('unable to find Contact record data for this record');
        }
    });
}

///////////////////////////////////////////////////////////////////////////
// Opens the modal, builds record list, retrieves records' details from
// the helper API
///////////////////////////////////////////////////////////////////////////
function openSalesSequenceDialog(module, recordIdList) {
    var dialog = $('#salesSequenceDialog');
    modalToggleHelper(dialog);

    var modalBody = dialog.find('.modal-body');
    modalBody.addClass('modal-preload-hidden');
    var modalContent = $('#salesSequenceContentWrapper');
    modalContent.addClass('hidden');
    $('#somePlaceholderIframe').addClass('hidden');
    $("#sales-sequence-save-btn").animate({opacity: "0"});
    $('#somePlaceholderPara').removeClass('hidden');

    $.ajax({
        method: "POST",
        data: {
            module: module,
            recordIdList: recordIdList,
        },
        url: "index.php?entryPoint=leadfwd_salessequence_helper",
        success: function(result) {

            result = JSON.parse(result);
            if(!result.success && result.message) {
                alert(result.message);
                return;
            }

            if(result.salesSequenceList) {
                // Empty everything in the select-sales-sequence select element
                // contains right now and replace it with one empty option and the
                // contents of result.salesSequenceList
                var salesSequenceOptionHTML = '<option></option>';
                $.each( result.salesSequenceList, function(k, v) {
                    salesSequenceOptionHTML += '<option value="' + k + '">' + v + '</option>';
                });
                selectEl = $('#select-sales-sequence');
                selectEl.empty();
                selectEl.append(salesSequenceOptionHTML);
            }

            // Set the record type and count in the h4 element
            var count = (result.recordList && result.recordList.length) || 0;
            h4El = $('#sales-sequence-record-count');

            var trueModule = module;
            if(module == 'Accounts' || module == 'Opportunities') {
                trueModule = 'Contacts';
            }

            h4El.text('You have selected ' + count + ' ' + trueModule);

            var modelList = [];
            if(result.recordList) {
                // Set the record list
                var recordListHTML = '';
                $.each( result.recordList, function(k, v) {
                    recordListHTML += '<li> ' + v.name;
                    recordListHTML += ' (<span style="color: ' + v.status_color + '">' + v.status + '</span>)';
                    recordListHTML += ' (<span class="alert-danger listViewEmpty" data-id="' + v.id + '" onclick="handleSaveSalesSequenceRemoveLine(this);return false;">x</span>)';
                    recordListHTML += '</li>';
                });
                ulEl = $('#sales-sequence-record-list');
                ulEl.empty();
                ulEl.append(recordListHTML);

                // Set a list of valid records
                $.each( result.recordList, function(k, v) {
                    if(v.status.toLowerCase().includes('valid')) {
                        modelList.push({
                            emailAddress: v.email,
                            id: v.id,
                            name: v.name,
                        });
                    }
                });
            }

            // Build the parts we have of the Sales Sequence API call and save it
            // in a hidden field
            var postData = {
                module: module,
                recordList: modelList,
            };
            var postDataString = JSON.stringify(postData);
            $('#sales-sequence-postdata-json').val(postDataString);

            // Remove loading message and let the content show
            modalBody.removeClass('modal-preload-hidden');
            modalContent.removeClass('hidden');

        },
        error: function(result) {
            modalBody.removeClass('modal-preload-hidden');
            alert('unable to load list results');
        }
    });
}

///////////////////////////////////////////////////////////////////////////
// function to handle user selection of a Sales Sequence, which should load
// a preview of the Sales Sequence details from the LeadFWD API
///////////////////////////////////////////////////////////////////////////
function handleSelectSalesSequence(el) {
    var salesSequenceID = el.value;

    var postDataString = $('#sales-sequence-postdata-json').val();
    var postData = $.parseJSON(postDataString);
    postData.salesSequenceID = salesSequenceID;
    postDataString = JSON.stringify(postData);
    $('#sales-sequence-postdata-json').val(postDataString);

    var recordList = postData.recordList;

    $.ajax({
        url: "index.php?entryPoint=inbox25_url&fullurlandheight=true",
        success: function(result) {

            result = JSON.parse(result);

            var previewPostURL = result.config_url
                + '&seq=' + salesSequenceID
                + result.ts
                + result.suid
                + result.mv
                + result.system;

            var frameSource = "<form id='tempId' action='" + previewPostURL + "' method='post'>";
            frameSource += "<input type='hidden' name='json' value='" + postDataString + "' />";
            frameSource += "</form>";
            frameSource += "<script type='text/javascript'>";
            frameSource += "document.forms['tempId'].submit();";
            frameSource += "</" + "script" + ">";

            $('#somePlaceholderIframe').removeClass('hidden');
            $('#somePlaceholderPara').addClass('hidden');
            $('#somePlaceholderIframe').attr('srcdoc', frameSource);

            // Only allow the save btn to show if there are valid records
            if(recordList && recordList.length > 0) {
                $("#sales-sequence-save-btn").animate({opacity: "1"});
            }

        },
        error: function(result) {
            alert('Unable to load Sales Sequence preview');
        }
    });

}

///////////////////////////////////////////////////////////////////////////
// Invoked when user clicks the save checkbox button
///////////////////////////////////////////////////////////////////////////
function handleSaveSalesSequence(el) {

    // Sets the dialog area back to its loading state
    var dialog = $('#salesSequenceDialog');
    var modalBody = dialog.find('.modal-body');
    var modalContent = $('#salesSequenceContentWrapper');
    modalBody.addClass('modal-preload-hidden');
    modalContent.addClass('hidden');

    // Retrieves already stored information about the Module and Record List
    var postDataString = $('#sales-sequence-postdata-json').val();
    var postData = $.parseJSON(postDataString);
    var module = postData.module;
    var recordList = postData.recordList;
    var salesSequenceID = postData.salesSequenceID;

    if(module == 'Accounts' || module == 'Opportunities') {
        module = 'Contacts';
    }

    // Converts the list of Record Data to a list of Record IDs
    var recordIdList = [];
    $.each( recordList, function(k, v) {
        recordIdList.push(v.id);
    });
    var jsonRecordIdList = JSON.stringify(recordIdList);

    $.ajax({
        url: "index.php?entryPoint=inbox25_url&fullurlandheight=true",
        success: function(result) {
            result = JSON.parse(result);
            var inbox25_api_url = result.inbox25_api_url;
            var inbox25_api_params = result.inbox25_api_params;
            var ts = result.ts;

            // Builds the full API POST payload
            var dataString = inbox25_api_params;
            dataString += '&action_type=sequence';
            dataString += '&sugar_module=' + module;
            dataString += '&sequence_id=' + salesSequenceID;
            dataString += '&sugar_id=' + jsonRecordIdList;
            dataString += ts;

            $.ajax({
                method: 'POST',
                url: inbox25_api_url,
                data: dataString,
            }).done(function() {

                modalBody.removeClass('modal-preload-hidden');
                modalBody.append('\
                    <h1 class="success">\
                        <span class="suitepicon suitepicon-action-view-project-tasks green"></span>\
                    </h1>\
                ');

                modalBody.css('position', 'relative');
                modalBody.css('text-align', 'center');

                setTimeout(function(){
                    modalToggleHelper(dialog);
                    modalBody.css('position', 'absolute');
                    modalBody.css('text-align', 'start');
                    modalBody.find('.success').remove();
                }, 1500);

            }).fail(function(response) {
                console.log(response);
                alert('error sending sales sequnce information to LeadFWD API');
                modalToggleHelper(dialog);
            });

        },
        error: function(result) {
            console.log(result);
            alert('Unable to load authorization data for sales sequence save');
        }
    });

}

///////////////////////////////////////////////////////////////////////////
// Invoked when user clicks the "X" icon on a contact
///////////////////////////////////////////////////////////////////////////
function handleSaveSalesSequenceRemoveLine(el) {
    // Which record is it that we want to remove?
    var removeRecordID = el.dataset.id

    // Retrieves already stored information about the Module and Record List
    var postDataString = $('#sales-sequence-postdata-json').val();
    var postData = $.parseJSON(postDataString);
    var recordList = postData.recordList;

    // Removes desired record from storage list
    var newRecordList = [];
    $.each( recordList, function(k, v) {
        if(v.id != removeRecordID) {
            newRecordList.push(v);
        }
    });
    postData.recordList = newRecordList;
    var postDataString = JSON.stringify(postData);
    $('#sales-sequence-postdata-json').val(postDataString);

    // Removes desired row from the UI
    $(el).closest('li').remove();
}

///////////////////////////////////////////////////////////////////////////
// When available, we'll just use $.modal, but in SugarCRM 6.5 CE that's
// not an option so we need an alternative
///////////////////////////////////////////////////////////////////////////
function modalToggleHelper(subj) {
    if($ && $.fn && $.fn.modal) {
        subj.modal('toggle');
    } else {
        if(subj.hasClass('in')) {
            subj.removeClass('in');
        } else {
            subj.addClass('in');
        }
    }
}

///////////////////////////////////////////////////////////////////////////
// Creates the Sales Sequence div, which will remain hidden until activated
///////////////////////////////////////////////////////////////////////////
var salesSequenceDialog = '\
<div id="salesSequenceDialog" class="modal fade modal-salesSequence" tabindex="-1" role="dialog"> \
    <div class="modal-dialog modal-lg" style="width:90%;position:absolute;left:0;right:0;margin-left:auto;margin-right:auto;top:30px;bottom:30px;"> \
        <div class="modal-content" style="height:100%;width:100%;"> \
            <div class="modal-header"> \
                <button type="button" id="sales-sequence-close-btn" class="button pull-right list-view-action-buttons" data-dismiss="modal" aria-label="Close"> \
                    Close\
                </button> \
                <button type="button" id="sales-sequence-save-btn" class="button pull-right list-view-action-buttons" aria-label="Save" onclick="handleSaveSalesSequence(this);return false;"> \
                Add to sequence\
                </button> \
                <h4 class="modal-title"> Add to Sequence </h4> \
            </div> \
            <div class="modal-body modal-preload-hidden" id="salesSequence" style="position:absolute;top:70px;bottom:0;width:100%;"> \
                <div class="row detail-view-row hidden" id="salesSequenceContentWrapper" style="height:100%;"> \
                    <div class="col-xs-12 col-sm-6 detail-view-row-item salesSequenceLeft"> \
                        <h4>Sales Sequence list</h4> \
                        <select id="select-sales-sequence" name="select-sales-sequence" onchange="handleSelectSalesSequence(this);"> \
                            <option></option> \
                        </select> \
                        <br /> \
                        <h4 id="sales-sequence-record-count">selection placeholder</h4> \
                        <ul id="sales-sequence-record-list" style="list-style-type:disc;padding-left:20px;"> \
                        </ul> \
                    </div> \
                    <div class="col-xs-12 col-sm-6 detail-view-row-item salesSequenceRight" style="height:100%;"> \
                        <p id="somePlaceholderPara">Please select a Sales Sequence</p> \
                        <iframe style="width:100%;height:100%;border-width:0;" class="hidden" id="somePlaceholderIframe"></iframe> \
                        <input type="hidden" class="hidden" id="sales-sequence-postdata-json" /> \
                    </div> \
                </div> \
            </div> \
        </div> \
    </div> \
</div>';
